From 7553b8ac874fde299ccc133b8153fd3dc6838e22 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 14 2015 00:50:11 +0000
Subject: [PATCH 118/254] Expose some more information via the json api.


---

diff --git a/hubs/app.py b/hubs/app.py
index cbc22e7..74ea4af 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -60,34 +60,17 @@ def index():
 @app.route('/<name>')
 @app.route('/<name>/')
 def hub(name):
-    hub = session.query(hubs.models.Hub)\
-        .filter(hubs.models.Hub.name==name)\
-        .first()
-
-    if not hub:
-        flask.abort(404)
-
+    hub = get_hub(session, name)
     return flask.render_template('hubs.html', hub=hub, session=session)
 
 
-def get_widget(session, hub, idx):
-    try:
-        idx = int(idx)
-    except TypeError:
-        flask.abort(404)
-
-    hub = session.query(hubs.models.Hub)\
-        .filter(hubs.models.Hub.name==hub)\
-        .first()
-
-    if not hub:
-        flask.abort(404)
-
-    for widget in hub.widgets:
-        if widget.idx == idx:
-            return widget
-
-    flask.abort(404)
+@app.route('/<name>/json')
+@app.route('/<name>/json/')
+def hub_json(name):
+    hub = get_hub(session, name)
+    response = flask.jsonify(hub.__json__(session))
+    # TODO -- modify headers with response.headers['X-fedora-hubs-wat'] = 'foo'
+    return response
 
 
 @app.route('/<hub>/<idx>')
@@ -101,16 +84,8 @@ def widget_render(hub, idx):
 @app.route('/<hub>/<idx>/json/')
 def widget_json(hub, idx):
     widget = get_widget(session, hub, idx)
-    from hubs.widgets import registry
-    module = registry[widget.plugin]
-    data = module.data(session, widget, **widget.config)
-    response = flask.jsonify(data)
-
-    # We don't actually need these two headers.  Just messing around.
-    response.headers['X-fedora-hubs-hub-name'] = hub
-    response.headers['X-fedora-hubs-widget-id'] = idx
-    # TODO -- add other headers here as we decide we need them.
-
+    response = flask.jsonify(widget.__json__(session))
+    # TODO -- modify headers with response.headers['X-fedora-hubs-wat'] = 'foo'
     return response
 
 
@@ -223,6 +198,36 @@ def check_auth():
         flask.g.auth.email = flask.session.get('email', None)
 
 
+def get_hub(session, name):
+    """ Utility shorthand to get a hub and 404 if not found. """
+    hub = session.query(hubs.models.Hub)\
+        .filter(hubs.models.Hub.name==name)\
+        .first()
+
+    if not hub:
+        flask.abort(404)
+
+    return hub
+
+
+def get_widget(session, hub, idx):
+    """ Utility shorthand to get a widget and 404 if not found. """
+    try:
+        idx = int(idx)
+    except TypeError:
+        flask.abort(404)
+
+    hub = get_hub(session, hub)
+
+    for widget in hub.widgets:
+        if widget.idx == idx:
+            return widget
+
+    flask.abort(404)
+
+
+
+
 
 if __name__ == '__main__':
     app.run(debug=True)
diff --git a/hubs/models.py b/hubs/models.py
index e4c7fa4..ae2639e 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -123,9 +123,20 @@ class Hub(BASE):
             [w for w in self.widgets if not w.left],
             key=lambda w: w.index)
 
-    def __json__(self, reify=False):
+    def __json__(self, session):
         return {
             'name': self.name,
+            'summary': self.summary,
+
+            # TODO -- splash image
+
+            'widgets': [widget.idx for widget in self.widgets],
+            'left_width': self.left_width,
+
+            # TODO -- these three need to be fleshed out with real fas data.
+            'owners': self.owners,
+            'members': self.members,
+            'subscribers': self.subscribers,
         }
 
 def _config_default(context):
@@ -154,9 +165,19 @@ class Widget(BASE):
     def config_setter(self, config):
         self._config = json.dumps(config)
 
-    def __json__(self, reify=False):
+    def __json__(self, session):
+        module = hubs.widgets.registry[self.plugin]
+        data = module.data(session, self, **self.config)
         return {
+            'id': self.idx,
+            # TODO -- use flask.url_for to get the url for this widget
             'plugin': self.plugin,
+            'description': module.__doc__,
+            'hub': self.hub_id,
+            'left': self.left,
+            'index': self.index,
+            'data': data,
+            'config': self.config,
         }
 
     @property
@@ -174,10 +195,14 @@ class User(BASE):
     fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
 
-    def __json__(self, reify=False):
+    def __json__(self, session):
         return {
+            'username': self.username,
             'openid': self.openid,
+            'fullname': self.fullname,
             'created_on': self.created_on,
+            # We'll need hubs subscribed to, owned, etc..
+            #'hubs': [hub.idx for hub in self.hubx],
         }
 
     @property

